"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Program(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.models.Program": ga4gh_3_1_1.Program,
        }

    __slots__ = [
        "commandLine",
        "id",
        "name",
        "prevProgramId",
        "version",
    ]

    def __init__(
        self,
        commandLine=None,
        id=None,
        name=None,
        prevProgramId=None,
        version=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.Program model.

        :param commandLine:
            The command line used to run this program.
        :type commandLine: None | str
        :param id:
            The user specified ID of the program.
        :type id: None | str
        :param name:
            The name of the program.
        :type name: None | str
        :param prevProgramId:
            The ID of the program run before this one.
        :type prevProgramId: None | str
        :param version:
            The version of the program run.
        :type version: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
